@echo off

REM ===========================================================================

REM *** please check through this before you run it ***

REM *** This is an MS-DOS batch file ***
REM *** it assumes the existence of C:/Temp on Windoze ***
REM **** it deletes and creates some files and directories ***

REM *** written using SVN 1.6.5 ***

REM ===========================================================================

if exist C:\Temp\spb_repo (
	( rmdir /S /Q C:\Temp\spb_repo || ( echo "repo clean fail" & goto :EOF ) ) & REM *** dangerous! ***
)

if exist spb_wc (
	( rmdir /S /Q spb_wc || ( echo "wc clean fail" & goto :EOF ) ) & REM *** dangerous! ***
)

setlocal
SET repo_path="c:/Temp/spb_repo"
SET repo_url="file://localhost/c:/Temp/spb_repo/"
rem SET old_svn="C:\Program Files\Subversion_1.4.6\bin\"
rem SET svn="C:\Program Files\Subversion_\bin\"

echo ========
echo *** r0: create a repository ***
%svn%svnadmin create %repo_path% || ( echo "create fail" & goto :EOF )
REM *** "committed" rev 0 ***

echo ========
echo *** create a working copy ***
%svn%svn checkout "%repo_url%" spb_wc || ( echo "co fail" & goto :EOF )
REM *** at revision 0 ***

echo ========
echo *** r1: populate the wc trunk, commit and update ***
mkdir spb_wc\trunk || ( echo "mkdir trunk fail" & goto :EOF )
echo "some file text" > spb_wc\trunk\file.txt || ( echo "init echo fail" & goto :EOF )
%svn%svn add spb_wc/trunk || ( echo "init add fail" & goto :EOF )
%svn%svn commit --message "initial version" spb_wc || ( echo "init ci r1 fail" & goto :EOF )
REM *** committed rev 1 ***
%svn%svn update spb_wc || ( echo "up r1 fail" & goto :EOF )
REM *** at revision 1 ***

echo ========
echo *** r2: create a branch and update ***
%svn%svn copy --message "create branch" -r1 "%repo_url%trunk" "%repo_url%branch" || ( echo "cp fail" & goto :EOF )
REM *** committed rev 2 ***
%svn%svn update spb_wc || ( echo "up r2 fail" & goto :EOF )
REM *** at revision 2 ***

echo ========
echo *** rr3,4: edits on the trunk and the branch, commits and update ***
echo "changed text on trunk" > spb_wc\trunk\file.txt || ( echo "edit r3 fail" & goto :EOF )
%svn%svn commit --message "trunk edit" spb_wc || ( echo "trunk ci r3 fail" & goto :EOF )
REM *** committed rev 3 ***
echo "changed text on branch" > spb_wc\branch\file.txt || ( echo "edit r4 fail" & goto :EOF )
%svn%svn commit --message "branch edit" spb_wc || ( echo "branch ci r4 fail" & goto :EOF )
REM *** committed rev 4 ***
%svn%svn update spb_wc || ( echo "up r4 fail" & goto :EOF )
REM *** at revision 4 ***

echo ========
echo *** r5: delete the trunk and commit ***
%svn%svn delete --message "trunk delete" %repo_url%/trunk || ( echo "trunk delete r5 fail" & goto :EOF )
REM *** committed rev 5 ***
%svn%svn update spb_wc || ( echo "up r5 fail" & goto :EOF )
REM *** at revision 5 ***

echo ========
echo *** r6: edit the branch, commit ***
echo "further changed text on branch" > spb_wc\branch\file.txt || ( echo "edit r6 fail" & goto :EOF )
%svn%svn commit --message "further branch edit" spb_wc || ( echo "ci r6 fail" & goto :EOF )
REM *** committed rev 6 ***

echo ========
echo *** r7: move the branch to the trunk and update ***
%svn%svn move --message "move branch back to trunk" %repo_url%/branch %repo_url%/trunk || ( echo "move r7 fail" & goto :EOF )
REM *** committed rev 7 ***
%svn%svn update spb_wc || ( echo "up r7 fail" & goto :EOF )
REM *** at revision 7 ***

echo ========
echo *** r8: edit the new trunk, commit ***
echo "further changed text on trunk" > spb_wc\trunk\file.txt || ( echo "edit r8 fail" & goto :EOF )
%svn%svn commit --message "new-trunk edit" spb_wc || ( echo "ci r8 fail" & goto :EOF )
REM *** committed rev 8 ***
%svn%svn update spb_wc || ( echo "up r7 fail" & goto :EOF )
REM *** at revision 8 ***

echo ========
echo *** log everything ***
echo ^> %svn%svn log -vr 1:HEAD spb_wc
%svn%svn log -vr 1:HEAD spb_wc || ( echo "log all fail" & goto :EOF )

echo ========
echo *** version info ***
%svn%svn --version

echo ========
echo "success"
